package com.airfrance.squalecommon.datatransfertobject.config;

import java.util.ArrayList;
import java.util.Collection;

/**
 * Tche Squalix
 * Les paramtres de la tche squalix sont placs dans ce DTO :
 * le taskDTO est en fait un merge entre les classes TaskRefBO et TaskBO
 */
public class TaskDTO {

    /**
     * Identifiant (au sens technique) de l'objet
     */
    private long mId;

    /** Le nom de la tche */
    private String mName;

    /** La classe correspondante  la tche */
    private String mClassName;

    /** Configuration possible de la tche*/
    private boolean mConfigurable;

    /** Configuration standard ou non */
    private boolean mStandard;

    /** indique si la tche est obligatoire */
    private boolean mMandatory;

    /** Paramtres de la tche sous la forme de TaskParameterDTO */
    private Collection mParameters = new ArrayList();

    /**
     * Mthode d'accs pour mId
     * 
     * @return la l'identifiant (au sens technique) de l'objet
     * 
     */
    public long getId() {
        return mId;
    }

    /**
     * Change la valeur de mId
     * 
     * @param pId le nouvel identifiant
     */
    public void setId(long pId) {
        mId = pId;
    }

    /**
     * Mthode d'accs  mName
     * 
     * @return le nom de la tche
     * 
     */
    public String getName() {
        return mName;
    }

    /**
     * Change la valeur de mName
     * 
     * @param pName le nouveau nom de la tche
     */
    public void setName(String pName) {
        mName = pName;
    }

    /**
     * Mthode d'accs  mClassName
     * 
     * @return le nom de la classe associe  la tche
     * 
     */
    public String getClassName() {
        return mClassName;
    }

    /**
     * Change la valeur de mClassName
     * 
     * @param pClassName la nouvelle classe associe
     */
    public void setClassName(String pClassName) {
        mClassName = pClassName;
    }

    /**
     * Mthode d'accs  mConfigurable
     * @return true si la tche est configurable
     */
    public boolean isConfigurable() {
        return mConfigurable;
    }

    /**
     * Change la valeur de mConfigurable
     * @param pConfigurable la nouvelle valeur de mConfigurable
     */
    public void setConfigurable(boolean pConfigurable) {
        mConfigurable = pConfigurable;
    }

    /**
     * Ajout d'un paramtre
     * @param pParameter paramtre
     */
    public void addParameter(TaskParameterDTO pParameter) {
        mParameters.add(pParameter);
    }

    /**
     * 
     * @return paramtres
     */
    public Collection getParameters() {
        return mParameters;
    }

    /**
     * @return true si la configuration est standard
     */
    public boolean isStandard() {
        return mStandard;
    }

    /**
     * @param pStandard true si la configuration est standard
     */
    public void setStandard(boolean pStandard) {
        mStandard = pStandard;
    }

    /**
     * @return true si la tche est obligatoire
     */
    public boolean isMandatory() {
        return mMandatory;
    }

    /**
     * @param pMandatory true si la tche est obligatoire
     */
    public void setMandatory(boolean pMandatory) {
        mMandatory = pMandatory;
    }

}
