package com.airfrance.squalecommon.datatransfertobject.stats;

import com.airfrance.squalecommon.datatransfertobject.config.ServeurDTO;

/**
 */
public class SiteStatsDTO extends CommonStatsDTO{

    /**
     * Le nom du serveur
     */
    private ServeurDTO mServeurDTO;

    /**
     * Le nombre d'applications avec des audits russis
     */
    private int nbAppliWithAuditsSuccessful;

    /**
     * Le nombre d'applications avec des audits mais aucun russi
     */
    private int nbAppliWithoutSuccessfulAudits;

    /**
     * Le nombre d'applications valides (<=> sans audits)
     */
    private int nbValidatedApplis;

    /**
     * Le nombre d'applications  valider
     */
    private int nbAppliToValidate;

    /**
     * Constructeur par dfaut
     */
    public SiteStatsDTO() {
        mServeurDTO = new ServeurDTO();
    }

    /**
     * @return le nombre d'appli  valider
     */
    public int getNbAppliToValidate() {
        return nbAppliToValidate;
    }

    /**
     * @return le nombre d'appli avec des audits russis
     */
    public int getNbAppliWithAuditsSuccessful() {
        return nbAppliWithAuditsSuccessful;
    }

    /**
     * @return le nombre d'applis avec des audits mais aucun russi
     */
    public int getNbAppliWithoutSuccessfulAudits() {
        return nbAppliWithoutSuccessfulAudits;
    }

    /**
     * @return le nombre d'applis valids
     */
    public int getNbValidatedApplis() {
        return nbValidatedApplis;
    }

    /**
     * @param pNbAppli le nombre d'applis  valider
     */
    public void setNbAppliToValidate(int pNbAppli) {
        nbAppliToValidate = pNbAppli;
    }

    /**
     * @param pNbAppli le nombre d'appli avec des audits russis
     */
    public void setNbAppliWithAuditsSuccessful(int pNbAppli) {
        nbAppliWithAuditsSuccessful = pNbAppli;
    }

    /**
     * @param pNbAppli le nombre d'appli sans audits russis
     */
    public void setNbAppliWithoutSuccessfulAudits(int pNbAppli) {
        nbAppliWithoutSuccessfulAudits = pNbAppli;
    }

    /**
     * @param pNbAppli le nombre d'applis valids
     */
    public void setNbValidatedApplis(int pNbAppli) {
        nbValidatedApplis = pNbAppli;
    }

    /**
     * @return le nom du serveur
     */
    public ServeurDTO getServeurDTO() {
        return mServeurDTO;
    }

    /**
     * @param pServeurDTO le nom du serveur
     */
    public void setServeurDTO(ServeurDTO pServeurDTO) {
        mServeurDTO = pServeurDTO;
    }

}
