/*
 * Cr le 12 juil. 05
 *
 * Pour changer le modle de ce fichier gnr, allez  :
 * Fentre&gt;Prfrences&gt;Java&gt;Gnration de code&gt;Code et commentaires
 */
package com.airfrance.squalecommon.datatransfertobject.transform.result;

import java.io.Serializable;

import com.airfrance.squalecommon.datatransfertobject.result.ErrorDTO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.AuditBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ProjectBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.result.ErrorBO;

/**
 * @author M400841
 *
 * Pour changer le modle de ce commentaire de type gnr, allez  :
 * Fentre&gt;Prfrences&gt;Java&gt;Gnration de code&gt;Code et commentaires
 */
public class ErrorTransform implements Serializable {

    /**
     * Constructeur prive
     */
    private ErrorTransform() {
    }

    /**
     * Copie complte de la DTO  la BO
     * DTO -> BO pour un Error
     * @param pErrorDTO ErrorDTO  transformer
     * @return ErrorBO
     */
    public static ErrorBO dto2Bo(ErrorDTO pErrorDTO) {
        
        // Initialisation du retour et la tache
        ErrorBO errorBO = new ErrorBO();
        errorBO.setTaskName(pErrorDTO.getTaskName());
        
        // Initialisation de l'audit
        AuditBO auditBO = new AuditBO();
        auditBO.setId(pErrorDTO.getAuditId());
        
        // Initialisation du sous-projet
        ProjectBO projectBO = new ProjectBO();
        projectBO.setId(pErrorDTO.getProjectId());
        
        errorBO.setAudit(auditBO);
        errorBO.setProject(projectBO);
        errorBO.setLevel(pErrorDTO.getLevel());
        
        return errorBO;
  
   }
  

    /**
     * Est utilis pour remonter une collection d'erreurs aux AC
     * BO -> DTO pour un Error
     * @param pErrorBO ErrorBO
     * @return ErrorDTO
     */
    public static ErrorDTO bo2Dto(ErrorBO pErrorBO) {
        
        // Initialisation du retour 
        ErrorDTO errorDTO = new ErrorDTO();
        
        errorDTO.setAuditId(pErrorBO.getAudit().getId());
        errorDTO.setLevel(pErrorBO.getLevel());
        errorDTO.setMessageKey(pErrorBO.getMessage());
        errorDTO.setTaskName(pErrorBO.getTaskName());
        errorDTO.setProjectId(pErrorBO.getProject().getId());
        
        return errorDTO;
        
    }

}
