package com.airfrance.squalecommon.enterpriselayer.businessobject.component;

import com.airfrance.squalecommon.enterpriselayer.businessobject.rule.QualityGridBO;

/**
 * Grille utilise dans un audit
 * 
 * @hibernate.class 
 * table="AuditGridBO"
 * mutable="true"
 */
public class AuditGridBO {
    /**
     * Identifiant (au sens technique) de l'objet
     */
    protected long mId;
    
    /** Projet */
    private ProjectBO mProject;
    /** Grille */
    private QualityGridBO mGrid;
    /** Audit (lien inverse */
    private AuditBO mAudit;
    
    /**
     * Access method for the mId property.
     * 
     * @return   the current value of the mId property
     * 
     * Note: unsaved-value An identifier property value that indicates that an instance 
     * is newly instantiated (unsaved), distinguishing it from transient instances that 
     * were saved or loaded in a previous session.  If not specified you will get an exception like this:
     * another object associated with the session has the same identifier
     * 
     * @hibernate.id generator-class="native"
     * type="long" 
     * column="AuditGridId" 
     * unsaved-value="-1" 
     * length="19"
     * @hibernate.generator-param name="sequence" value="auditgrid_sequence" 
     * 
     * @roseuid 42BFDEB701B4
     */
    public long getId() {
        return mId;
    }
    
    /**
     * Sets the value of the mId property.
     * 
     * @param pId the new value of the mId property
     * @roseuid 42BFDEB701F2
     */
    public void setId(long pId) {
        mId = pId;
    }
    
    
    /**
     * @return grille
     * 
     * @hibernate.many-to-one 
     * name="grid" 
     * column="QualityGridId" 
     * type="com.airfrance.squalecommon.enterpriselayer.businessobject.rule.QualityGridBO" 
     * not-null="false" 
     */
    public QualityGridBO getGrid() {
        return mGrid;
    }

    /**
     * @return grille
     * 
     * @hibernate.many-to-one 
     * name="project" 
     * column="ProjectId" 
     * type="com.airfrance.squalecommon.enterpriselayer.businessobject.component.ProjectBO" 
     * not-null="false" 
     */
    public ProjectBO getProject() {
        return mProject;
    }

    /**
     * @param pGridBO grille qualit
     */
    public void setGrid(QualityGridBO pGridBO) {
        mGrid = pGridBO;
    }

    /**
     * @param pProjectBO projet
     */
    public void setProject(ProjectBO pProjectBO) {
        mProject = pProjectBO;
    }

    /**
     * 
     * @return grilles qualit de l'audit
     * 
     * @hibernate.many-to-one 
     * column="AuditId" 
     * class="com.airfrance.squalecommon.enterpriselayer.businessobject.component.AuditBO"
     */
    public AuditBO getAudit() {
        return mAudit;
    }
    /**
     * @param pAuditBO audit
     */
    public void setAudit(AuditBO pAuditBO) {
        mAudit = pAuditBO;
    }

}
