package com.airfrance.squalecommon.enterpriselayer.businessobject.rulechecking.checkstyle;

import java.util.HashSet;
import java.util.Set;

import com.airfrance.squalecommon.enterpriselayer.businessobject.rulechecking.RuleBO;

/**
 * Rgle checkstyle
 * @hibernate.subclass
 * discriminator-value="Checkstyle"
 */
public class CheckstyleRuleBO extends RuleBO {

    /**
     * Liste des modules
     */
    protected Set mModules = new HashSet();
    
    /**
     * Access method for the mModules property.
     * 
     * @return   the current value of the mModules property
     * 
     * @hibernate.set 
     * name="modules" 
     * lazy="true" 
     * cascade="all"
     * @hibernate.collection-key 
     * column="RuleId"
     * @hibernate.collection-one-to-many 
     * class="com.airfrance.squalecommon.enterpriselayer.businessobject.rulechecking.checkstyle.CheckstyleModuleBO" 
     */
    
    public Set getModules() {
        return mModules;
    }
    
    /**
     * Sets the value of the mModules property.
     * 
     * @param pModules the new value of the mModules property
     **/
    
    public void setModules(Set pModules) {
        mModules = pModules;
    }
    /**
     * rajoute le module  la liste des modules de la rgle
     * @param pModule module checkstyle
     * @throws MissingSeverityException si l'attribut severity est absent du module
     * @throws MismatchSeverityException si l'attribut severity du module est incohrent avec la svrit
     * de la rgle
     */
    public void addModule(CheckstyleModuleBO pModule) throws MissingSeverityException, MismatchSeverityException{
        
        if (pModule.getSeverity() != null) {

            if ((mSeverity == null)) {// premire module  tre regroupe sous cette regle interne
                               
                setSeverity(pModule.getSeverity());
                pModule.setRule(this);
                
                mModules.add(pModule);
                
            } else {
                // on ne peut regrouper que des modules qui ont la mme sverit sous un mme code
                if (mSeverity.equals(pModule.getSeverity())) {
                   
                    setSeverity(pModule.getSeverity());
                    pModule.setRule(this);
                    mModules.add(pModule);
                } else {
                    throw new MismatchSeverityException();
                }
            }
            

        } else {
            throw new MissingSeverityException();
        }        
    }
   /**
    * Exception de svrit manquante
    * Leve lorsque l'attribut severity est absent
    */
   public class MissingSeverityException extends Exception {
   }
   /**
    * Exception d'incohrence de svrit
    * Leve lorsque la svrit d'un module checkstyle est incompatible
    * avec celle de la rgle checkstyle
    */
   public class MismatchSeverityException extends Exception {
   }
}
