package com.airfrance.squalecommon.enterpriselayer.applicationcomponent.display;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import com.airfrance.jraf.commons.exception.JrafDaoException;
import com.airfrance.jraf.commons.exception.JrafEnterpriseException;
import com.airfrance.squalecommon.SqualeTestCase;
import com.airfrance.squalecommon.daolayer.component.AbstractComponentDAOImpl;
import com.airfrance.squalecommon.daolayer.component.AuditDAOImpl;
import com.airfrance.squalecommon.daolayer.component.ProjectDAOImpl;
import com.airfrance.squalecommon.daolayer.rule.QualityGridDAOImpl;
import com.airfrance.squalecommon.datatransfertobject.component.ComponentDTO;
import com.airfrance.squalecommon.datatransfertobject.rule.QualityGridDTO;
import com.airfrance.squalecommon.datatransfertobject.transform.component.ComponentTransform;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ApplicationBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.AuditBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ClassBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.MethodBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.PackageBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ProjectBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.config.ProjectProfileBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.rule.QualityGridBO;
import com.airfrance.squalecommon.enterpriselayer.facade.rule.AuditComputing;
import com.airfrance.squalecommon.enterpriselayer.facade.rule.QualityGridImport;

/**
 * @author M400841
 *
 * Pour changer le modle de ce commentaire de type gnr, allez  :
 * Fentre&gt;Prfrences&gt;Java&gt;Gnration de code&gt;Code et commentaires
 */
public class ResultsApplicationComponentAccessTest extends SqualeTestCase {

    /**
     * @throws JrafEnterpriseException si erreur
     * @throws JrafDaoException si erreur
     */
    public void testGetApplicationResults() throws JrafEnterpriseException, JrafDaoException {
        getSession().beginTransaction();
        ResultsApplicationComponentAccess resultAccess = new ResultsApplicationComponentAccess();
        // Chargement de la grille
        InputStream stream = getClass().getClassLoader().getResourceAsStream("data/grid/grid_compute.xml");
        StringBuffer errors = new StringBuffer();
        Collection grids;
        grids = QualityGridImport.createGrid(stream, errors);
        QualityGridBO grid = (QualityGridBO) QualityGridDAOImpl.getInstance().load(getSession(), new Long(((QualityGridDTO) grids.iterator().next()).getId()));
        // Cration de l'application
        ApplicationBO application = getComponentFactory().createApplication(getSession());
        // Cration du projet
        ProjectBO project = getComponentFactory().createProject(getSession(), application, grid);
        // cration du profil du projet
        ProjectProfileBO profileBO = getComponentFactory().createProjectProfile(getSession());
        project.setProfile(profileBO);
        ProjectDAOImpl.getInstance().save(getSession(), project);
        // Cration de l'audit
        AuditBO audit = new AuditBO();
        audit.setStatus(AuditBO.TERMINATED);
        audit.setName("audit1");
        AuditDAOImpl.getInstance().create(getSession(), audit);
        application.addAudit(audit);
        AbstractComponentDAOImpl.getInstance().save(getSession(), application);
        project.addAudit(audit);
        AbstractComponentDAOImpl.getInstance().save(getSession(), project);
        // Cration du package
        PackageBO pkg = getComponentFactory().createPackage(getSession(), project);
        pkg.addAudit(audit);
        AbstractComponentDAOImpl.getInstance().save(getSession(), pkg);
        // Cration de la classe
        ClassBO cls = getComponentFactory().createClass(getSession(), pkg);
        cls.addAudit(audit);
        AbstractComponentDAOImpl.getInstance().save(getSession(), cls);
        // Cration de la mthode
        MethodBO method = getComponentFactory().createMethod(getSession(), cls);
        method.addAudit(audit);
        AbstractComponentDAOImpl.getInstance().save(getSession(), cls);
        getComponentFactory().createMeasures(getSession(), audit, project, cls, method);
        // Calcul de l'audit
        AuditComputing.computeAuditResult(getSession(), project, audit);
        getSession().commitTransactionWithoutClose();
        ComponentDTO appliDTO = ComponentTransform.bo2Dto(application);
        List components = new ArrayList();
        components.add(appliDTO);
        List appliResults = resultAccess.getApplicationResults(components, null);
        // On doit avoir les rsultats pour sloc et comments de rsm
        assertEquals(1, appliResults.size());
    }

}
