package com.airfrance.squaleweb.applicationlayer.action.component;

import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collection;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.airfrance.jraf.commons.exception.JrafEnterpriseException;
import com.airfrance.jraf.helper.AccessDelegateHelper;
import com.airfrance.jraf.spi.accessdelegate.IApplicationComponent;
import com.airfrance.squalecommon.datatransfertobject.component.ApplicationConfDTO;
import com.airfrance.squalecommon.datatransfertobject.component.AuditDTO;
import com.airfrance.squalecommon.datatransfertobject.component.ProjectConfDTO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ApplicationBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.AuditBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ProjectBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.profile.ProfileBO;
import com.airfrance.squalecommon.util.SqualeCommonConstants;
import com.airfrance.squalecommon.util.SqualeCommonUtils;
import com.airfrance.squalecommon.util.mail.MailerHelper;
import com.airfrance.squaleweb.applicationlayer.action.ActionUtils;
import com.airfrance.squaleweb.applicationlayer.action.accessRights.ReaderAction;
import com.airfrance.squaleweb.applicationlayer.formbean.LogonBean;
import com.airfrance.squaleweb.applicationlayer.formbean.component.AuditForm;
import com.airfrance.squaleweb.applicationlayer.formbean.config.ServeurListForm;
import com.airfrance.squaleweb.applicationlayer.formbean.creation.ApplicationRightsForm;
import com.airfrance.squaleweb.applicationlayer.formbean.creation.CreateApplicationForm;
import com.airfrance.squaleweb.applicationlayer.formbean.creation.CreateProjectForm;
import com.airfrance.squaleweb.resources.WebMessages;
import com.airfrance.squaleweb.transformer.ApplicationConfTransformer;
import com.airfrance.squaleweb.transformer.AuditTransformer;
import com.airfrance.squaleweb.transformer.ProjectConfTransformer;
import com.airfrance.squaleweb.transformer.ServeurListTransformer;
import com.airfrance.squaleweb.util.SqualeWebActionUtils;
import com.airfrance.welcom.struts.bean.WActionForm;
import com.airfrance.welcom.struts.transformer.WTransformerException;
import com.airfrance.welcom.struts.transformer.WTransformerFactory;
import com.airfrance.welcom.struts.util.WConstants;

/**
 */
public class ManageApplicationAction extends ReaderAction {

    /**
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward config(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;

        try {
            // On rcupre l'aplication courante
            CreateApplicationForm application = (CreateApplicationForm) pForm;
            validateConfig(pForm, errors);
            // Renvoi vers la page d'attribution des droits
            forward = pMapping.findForward("add_rights");
            if (pRequest.getParameter("modification") != null && errors.isEmpty()) {
                // Obtention de l'AC
                IApplicationComponent ac = AccessDelegateHelper.getInstance("ApplicationAdmin");
                ApplicationConfDTO applicationDTO = (ApplicationConfDTO) WTransformerFactory.formToObj(ApplicationConfTransformer.class, application)[0];
                // On change le nom de l'utilisateur et la date de dernire modification
                applicationDTO.setLastUser(((LogonBean) pRequest.getSession().getAttribute(WConstants.USER_KEY)).getMatricule());
                applicationDTO.setLastUpdate(Calendar.getInstance().getTime());
                Object[] paramIn = { applicationDTO };
                forward = pMapping.findForward("application_summary");
                if (((Integer) ac.execute("saveApplication", paramIn)).intValue() != 0) {
                    // Renvoi d'un message gnrique suite  l'chec de sauvegarde de l'application
                    ActionMessage error = new ActionMessage("error.application_not_saved");
                    errors.add(ActionMessages.GLOBAL_MESSAGE, error);
                    saveMessages(pRequest, errors);
                    forward = pMapping.findForward("total_failure");
                } else {
                    // l'application est recharge afin de mettre  jour le nom du serveur
                    applicationDTO = (ApplicationConfDTO) ac.execute("getApplicationConf", paramIn);
                    application = (CreateApplicationForm) WTransformerFactory.objToForm(ApplicationConfTransformer.class, applicationDTO);
                    pRequest.getSession().setAttribute("createApplicationForm", application);
                    loadLastBranchAuditInSession(pRequest, applicationDTO.getId());
                }
                ActionUtils.refreshUser(pRequest);
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            // Transfert vers la page d'erreur
            forward = pMapping.findForward("total_failure");
        }
        if (!errors.isEmpty()) {
            // On sauvegarde les erreurs pour les afficher sur la page initiale
            saveMessages(pRequest, errors);
            // On renvoie vers la page initiale avec message d'erreur
            try {
                IApplicationComponent ac = AccessDelegateHelper.getInstance("Serveur");
                Collection lListeServeurDTO = (Collection) ac.execute("listeServeurs");
                ServeurListForm lListeServeurForm = new ServeurListForm();
                WTransformerFactory.objToForm(ServeurListTransformer.class, lListeServeurForm, lListeServeurDTO);
                pRequest.setAttribute("listeServeur", lListeServeurForm);
                forward = pMapping.findForward("config_application");
            } catch (Exception e) {
                // Traitement factoris des exceptions
                handleException(e, errors, pRequest);
            }
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);

        return forward;
    }

    /**
      * @param pMapping le mapping.
      * @param pForm le formulaire  lire.
      * @param pRequest la requte HTTP.
      * @param pResponse la rponse de la servlet.
      * @return l'action  raliser.
      */
    public ActionForward configAndForward(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;

        try {
            validateConfig(pForm, errors);
            forward = pMapping.findForward("add_rights");
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        if (!errors.isEmpty()) {
            // On sauvegarde les erreurs pour les afficher sur la page initiale
            saveMessages(pRequest, errors);
            // On renvoie vers la page initiale avec message d'erreur
            try {
                IApplicationComponent ac = AccessDelegateHelper.getInstance("Serveur");
                Collection lListeServeurDTO = (Collection) ac.execute("listeServeurs");
                ServeurListForm lListeServeurForm = new ServeurListForm();
                WTransformerFactory.objToForm(ServeurListTransformer.class, lListeServeurForm, lListeServeurDTO);
                pRequest.setAttribute("listeServeur", lListeServeurForm);

                forward = pMapping.findForward("config_application");
            } catch (Exception e) {
                // Factorisation du traitement des exceptions
                handleException(e, errors, pRequest);
            }
        }
        return forward;
    }

    /**
     * @param pForm le formulaire
     * @param pErrors les erreurs
     */
    private void validateConfig(ActionForm pForm, ActionMessages pErrors) {
        // On rcupre l'aplication courante
        CreateApplicationForm application = (CreateApplicationForm) pForm;
        // Vrification de la validit de la saisie en fonction de l'audit
        if ((!application.isMilestone() && application.getAuditFrequency() < 1) || application.getPurgeDelay() < 1) {
            ActionMessage error = null;
            // On raffecte la valeur par dfaut au champ qui n'est pas bien rempli
            if (application.getAuditFrequency() < 1) {
                error = new ActionMessage("error.invalid_audit_frequency");
                application.setAuditFrequency(CreateApplicationForm.DEFAULT_AUDIT_FREQUENCY);
                pErrors.add(ActionMessages.GLOBAL_MESSAGE, error);
            } // Eventuellement les 2
            if (application.getPurgeDelay() < 1) {
                application.setPurgeDelay(CreateApplicationForm.DEFAULT_PURGE_DELAY);
                error = new ActionMessage("error.invalid_purge_delay");
                pErrors.add(ActionMessages.GLOBAL_MESSAGE, error);
            }
        }
        // Vrification de la validit de saisie du site
        if (application.getServeurForm().getServeurId() == 0) {
            // Le site est un obligatoire --> erreur si pas renseign
            ActionMessage error = new ActionMessage("error.invalid_site");
            pErrors.add(ActionMessages.GLOBAL_MESSAGE, error);
        }
        // vrification que la frquence de purge est suprieur  celle d'audits de suivi
        if (application.getPurgeDelay() < application.getAuditFrequency()) {
            ActionMessage error = new ActionMessage("error.purge_frequency");
            pErrors.add(ActionMessages.GLOBAL_MESSAGE, error);
        }
    }

    /**
     * Finalise la modification du projet en base de donnes,
     * aprs avoir ajout les utilisateurs.
     * 
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward addRights(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        // Cette action est la dernire  tre appele aprs
        // chaque tape de configuration d'application
        // Elle ralise la sauvegarde dans la base des donnes collectes
        try {
            ApplicationRightsForm form = (ApplicationRightsForm) pForm;
            CreateApplicationForm createApplicationForm = (CreateApplicationForm) pRequest.getSession().getAttribute("createApplicationForm");
            // Rcupration de la liste des utilisateurs dans le formulaire
            HashMap users = new HashMap();
            boolean hasManager = Arrays.asList(form.getRightProfile()).contains(ProfileBO.MANAGER_PROFILE_NAME);
            for (int i = 0; null != form.getMatricule() && i < form.getMatricule().length; i++) {
                // On vrifie que l'utilisateur  ajouter possde un matricule valide
                String matricule = form.getMatricule()[i].trim();
                if (matricule.length() > 0) {
                    String right = form.getRightProfile()[i];
                    // On vrifie que l'utilisateur n'existe pas dj avec des droits diffrents
                    String userRight = (String) users.get(matricule);
                    if (userRight != null && !userRight.equals(right)) {
                        // Erreur de configuration
                        ActionMessage error = new ActionMessage("error.application_more_than_one_right");
                        errors.add(ActionMessages.GLOBAL_MESSAGE, error);
                        saveMessages(pRequest, errors);
                        forward = pMapping.findForward("failure");
                    }
                    users.put(matricule, right);
                }
            }
            if (!hasManager) {
                // Message d'erreur
                ActionMessage error = new ActionMessage("error.application_without_manager");
                errors.add(ActionMessages.GLOBAL_MESSAGE, error);
                saveMessages(pRequest, errors);
                forward = pMapping.findForward("failure");
            }
            // On nettoie les matricules
            form.setMatricule(SqualeWebActionUtils.cleanValues(form.getMatricule()));
            // si il n'y a pas d'erreur on enregistre les modifications
            if (errors.isEmpty()) {
                // On ajoute la liste des droits  l'instance de l'application en cours de modification
                createApplicationForm.setRights(users);
                // On vrifie en base que le nom est disponible
                ApplicationConfDTO application = (ApplicationConfDTO) WTransformerFactory.formToObj(ApplicationConfTransformer.class, createApplicationForm)[0];
                // Obtention de l'AC
                IApplicationComponent ac = AccessDelegateHelper.getInstance("ApplicationAdmin");
                // On change le nom de l'utilisateur et la date de dernire modification
                application.setLastUser(((LogonBean) pRequest.getSession().getAttribute(WConstants.USER_KEY)).getMatricule());
                application.setLastUpdate(Calendar.getInstance().getTime());
                Object[] paramIn = { application };
                forward = pMapping.findForward("success");
                if (((Integer) ac.execute("saveApplication", paramIn)).intValue() != 0) {
                    // Renvoi d'un message gnrique suite  l'chec de sauvegarde de l'application
                    ActionMessage error = new ActionMessage("error.application_not_saved");
                    errors.add(ActionMessages.GLOBAL_MESSAGE, error);
                    saveMessages(pRequest, errors);
                    forward = pMapping.findForward("total_failure");
                } else {
                    // l'application est recharge afin de mettre  jour le nom du serveur
                    application = (ApplicationConfDTO) ac.execute("getApplicationConf", paramIn);
                    createApplicationForm = (CreateApplicationForm) WTransformerFactory.objToForm(ApplicationConfTransformer.class, application);
                    pRequest.getSession().setAttribute("createApplicationForm", createApplicationForm);
                    ActionUtils.refreshUser(pRequest);
                }

            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);

        return (forward);
    }

    /**
     * Slectionne l'application  configurer
     * 
      * @param pMapping le mapping.
      * @param pForm le formulaire  lire.
      * @param pRequest la requte HTTP.
      * @param pResponse la rponse de la servlet.
      * @return l'action  raliser.
     */
    public ActionForward selectApplicationToConfig(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;

        try {
            // Rcupration de l'application depuis la requte
            String applicationId = pRequest.getParameter("applicationId");
            ApplicationConfDTO dto = ManageApplicationUtils.getApplication(applicationId);
            if (null == dto) {
                // Message gnrique si l'application n'existe pas
                ActionMessage error = new ActionMessage("error.application_not_got");
                errors.add(ActionMessages.GLOBAL_MESSAGE, error);
            } else {
                ManageApplicationUtils.getCreateApplicationForm(applicationId, pRequest);
                loadLastBranchAuditInSession(pRequest, dto.getId());
                forward = pMapping.findForward("application_summary");
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions
            handleException(e, errors, pRequest);
        }
        if (!errors.isEmpty()) {
            // Sauvegarde des messages
            saveMessages(pRequest, errors);
            // Transfert vers la page d'erreur
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);
        return forward;
    }

    /**
     * 
     * Ajoute un projet  l'application actuellement en cours de configuration
     * 
      * @param pMapping le mapping.
      * @param pForm le formulaire  lire.
      * @param pRequest la requte HTTP.
      * @param pResponse la rponse de la servlet.
      * @return l'action  raliser.
      */
    public ActionForward addProject(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        try {
            CreateProjectForm project = (CreateProjectForm) pForm;
            // Rcupre la config du projet
            Collection tasksDTO = getConfig(project, pRequest, errors, true);
            if (!errors.isEmpty()) {
                saveMessages(pRequest, errors);
                forward = pMapping.findForward("save_failure");
            } else {
                // on sauvegarde le projet
                forward = new CreateProjectAction().saveProject(pMapping, project, pRequest, pResponse);
                if (tasksDTO.size() != 0) { // Il reste les outils  configurer
                    forward = pMapping.findForward("configure");
                }
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);
        return forward;
    }

    /**
     * 
     * Sauvegarde un projet de l'application actuellement en cours de configuration
     * 
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward saveProject(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        try {
            // On rcupre le formulaire de cration du projet
            CreateProjectForm project = (CreateProjectForm) pForm;

            // On sauvegarde le projet seulement si il n'y a pas eu d'erreurs 
            if (isNameAvailable(project, pRequest)) {
                forward = new CreateProjectAction().saveProject(pMapping, project, pRequest, pResponse);
            } else {
                ActionMessage error = new ActionMessage("project_creation.name.already_used");
                errors.add(ActionMessages.GLOBAL_MESSAGE, error);
                forward = pMapping.findForward("save_failure");
                saveMessages(pRequest, errors);
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);
        return forward;
    }

    /**
     * Mthode de factorisation
     * @param pForm le formulaire
     * @param pRequest la requete http
     * @param errors les messages  stocker
     * @param pCheckNeeded un boolen indiquant si on est dans un cas de lecture ou de modification
     * Si false, on ne vrifie pas, si true on effectue les vrifications sur le nom
     * @return la liste des taches que l'on a rcupr
     * @throws Exception en cas d'chec
     */
    private Collection getConfig(CreateProjectForm pForm, HttpServletRequest pRequest, ActionMessages errors, boolean pCheckNeeded) throws Exception {
        // On ajout le projet  l'application
        if (pCheckNeeded && !isNameAvailable(pForm, pRequest)) {
            ActionMessage error = new ActionMessage("project_creation.name.already_used");
            errors.add(ActionMessages.GLOBAL_MESSAGE, error);
        }
        // Il faut peut-tre configurer les tches
        IApplicationComponent ac = AccessDelegateHelper.getInstance("SqualixConfig");
        Object[] paramIn = { pForm.getSourceManagement(), pForm.getProfile()};
        // Excution de l'AC
        Collection tasksDTO = (Collection) ac.execute("getConfigurableTasks", paramIn);
        ArrayList configurableTasks = new ArrayList();
        configurableTasks.addAll(tasksDTO);
        pForm.setTasks(configurableTasks);
        return tasksDTO;
    }

    /**
     * Action trs simple juste dans le cas on on veut visualiser la configuration d'un projet
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward viewProjectConfig(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        ActionMessages errors = new ActionMessages();
        ActionForward forward = pMapping.findForward("configure");
        try {
            getConfig((CreateProjectForm) pForm, pRequest, errors, false);
            if (!errors.isEmpty()) {
                saveMessages(pRequest, errors);
                forward = pMapping.findForward("failure");
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);
        return forward;
    }

    /**
     * Supprime les projets slectionns de l'application
     * 
     * @param pMapping le mapping
     * @param pForm le formulaire
     * @param pRequest la requte
     * @param pResponse la rponse
     * @return l'action  raliser
     */
    public ActionForward deleteProjects(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        return changeProjectsStatus(pMapping, pForm, pRequest, ProjectBO.DELETED, "removeProject");
    }

    /**
     * Dsactive ou ractive les projets slectionns de l'application
     * 
     * @param pMapping le mapping
     * @param pForm le formulaire
     * @param pRequest la requte
     * @param pResponse la rponse
     * @return l'action  raliser
     */
    public ActionForward disactiveOrReactiveProjects(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        return changeProjectsStatus(pMapping, pForm, pRequest, ProjectBO.DISACTIVATED, "disactiveOrReactiveProject");
    }

    /**
     * @param pMapping le mapping
     * @param pForm le formulaire
     * @param pRequest la requte
     * @param pStatus le statut du projet
     * @param pMethod le nom de la mthode  appeler
     * @return l'action  raliser
     */
    private ActionForward changeProjectsStatus(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, int pStatus, String pMethod) {
        ActionForward forward = null;
        ActionErrors errors = new ActionErrors();
        try {
            // Rcupration des projets slectionns par checkbox
            CreateApplicationForm applicationForm = (CreateApplicationForm) pRequest.getSession().getAttribute("createApplicationForm");
            List projects = applicationForm.getProjects();
            List newProjects = new ArrayList();
            // On dfini une variable permettant de compter les modifications de statut
            int cpt = 0;
            ActionErrors messages = new ActionErrors();
            // Parcours de la slection et suppression de chaque projet
            IApplicationComponent ac = AccessDelegateHelper.getInstance("ApplicationAdmin");
            Object[] paramIn = new Object[1];
            for (int i = 0; i < projects.size(); i++) {
                CreateProjectForm projectForm = (CreateProjectForm) projects.get(i);
                CreateProjectForm newProjectForm = projectForm;
                if (projectForm.isSelected()) {
                    cpt++;
                    paramIn[0] = new Long(projectForm.getProjectId());
                    ProjectConfDTO result = (ProjectConfDTO) ac.execute(pMethod, paramIn);
                    // Construction d'un message de confirmation pour chaque
                    // projet modifi
                    ActionMessage message = new ActionMessage("info.update_project_" + pStatus + "_" + (result != null), projectForm.getProjectName());
                    messages.add("projectsMessages", message);
                    if (null != result) {
                        // On transforme
                        newProjectForm = (CreateProjectForm) WTransformerFactory.objToForm(ProjectConfTransformer.class, result);
                        // on affecte l'id de l'application
                        newProjectForm.setApplicationId(applicationForm.getApplicationId());
                    }
                }
                // Si il n'est pas supprim, on l'ajoute
                if (newProjectForm.getStatus() != ProjectBO.DELETED) {
                    newProjects.add(newProjectForm);
                }
                saveMessages(pRequest, messages);
            }
            // Vrification de la slection
            if (cpt < 1) {
                ActionError error = new ActionError("error.invalid_projects_selection");
                errors.add("invalid.selection", error);
            } else {
                // On enregistre les paramtres de dernires modifications pour l'application
                ac.execute("updateLastModifParams", new Object[]{new Long(Long.parseLong(applicationForm.getApplicationId())), pRequest.getRemoteUser(), Calendar.getInstance().getTime()});
                // On recharge l'application en session
                ApplicationConfDTO applicationDTO = (ApplicationConfDTO) WTransformerFactory.formToObj(ApplicationConfTransformer.class, applicationForm)[0];
                applicationDTO = (ApplicationConfDTO) ac.execute("getApplicationConf", new Object[]{applicationDTO});
                applicationForm = (CreateApplicationForm) WTransformerFactory.objToForm(ApplicationConfTransformer.class, applicationDTO);
                pRequest.getSession().setAttribute("createApplicationForm", applicationForm);
                ActionUtils.refreshUser(pRequest);
            }
            applicationForm.setProjects(newProjects);
            forward = pMapping.findForward("application_summary");
        } catch (Exception e) {
            // Traitement factoris des exceptions
            handleException(e, errors, pRequest);
            // Routage vers la page d'erreur
            forward = pMapping.findForward("total_failure");
        }
        if (!errors.isEmpty()) {
            //Enregistrement du message et routage vers la page d'erreur
            saveErrors(pRequest, errors);
        }
        return forward;
    }

    /**
     * 
     * Ajoute un audit de suivi  raliser sur l'application.
     * 
      * @param pMapping le mapping.
      * @param pForm le formulaire  lire.
      * @param pRequest la requte HTTP.
      * @param pResponse la rponse de la servlet.
      * @return l'action  raliser.
      */
    public ActionForward addMilestone(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        try {
            // Prparation de l'audit
            AuditDTO audit = (AuditDTO) WTransformerFactory.formToObj(AuditTransformer.class, (AuditForm) pForm)[0];
            // Placement des champs non dfinis dans le formulaire
            audit.setType(AuditBO.MILESTONE);
            if (null == audit.getHistoricalDate()) {
                // On affecte la date du jour
                Calendar today = GregorianCalendar.getInstance();
                audit.setHistoricalDate(today.getTime());
            }
            CreateApplicationForm application = (CreateApplicationForm) pRequest.getSession().getAttribute("createApplicationForm");
            audit.setApplicationId(new Long(application.getApplicationId()).longValue());
            // Obtention de l'AC
            IApplicationComponent ac = AccessDelegateHelper.getInstance("ApplicationAdmin");
            Object[] paramIn = { audit };
            forward = pMapping.findForward("success");
            // Excution de l'AC en vrifiant que l'insertion s'est bien passe
            AuditDTO result = (AuditDTO) ac.execute("addMilestone", paramIn);
            if (null == result) {
                // L'audit n'a pas un nom correct ou l'excution dans la base pose problme
                // On renvoie un message d'erreur neutre
                ActionMessage error = new ActionMessage("error.application.audit.not_saved");
                errors.add("milestoneMsg", error);
                saveMessages(pRequest, errors);
                forward = pMapping.findForward("failure");
            } else {
                ActionMessage message = new ActionMessage("info.audit_created", result.getName());
                errors.add("milestoneMsg", message);
                saveMessages(pRequest, errors);
                // Mise  jour du form dans la session
                application.setMilestoneAudit(result);
                pRequest.getSession().setAttribute("createApplicationForm", application);
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);
        return forward;
    }

    /**
     * 
     * Ajoute un audit de suivi  raliser sur l'application.
     * Les ventuels audits de suivi programms sont supprims au profit
     * du nouvel audit cr 
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward addBranch(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        try {
            AuditDTO lAuditDTO = (AuditDTO) WTransformerFactory.formToObj(AuditTransformer.class, (WActionForm) pForm)[0];
            IApplicationComponent ac = AccessDelegateHelper.getInstance("ApplicationAdmin");
            Object[] paramIn = { lAuditDTO };
            lAuditDTO = (AuditDTO) ac.execute("addBranch", paramIn);
            if (lAuditDTO != null) {
                // mise  jour de la date de l'audit de suivi programm dans le formulaire
                AuditForm lAuditForm = (AuditForm) WTransformerFactory.objToForm(AuditTransformer.class, new Object[] { lAuditDTO });
                pRequest.getSession().setAttribute("auditForm2", lAuditForm);
                forward = pMapping.findForward("success");
                errors.add("branchMsg", new ActionMessage("info.audit_branch_created"));
            } else {
                forward = pMapping.findForward("failure");
                errors.add("branchMsg", new ActionMessage("error.application.audit.not_saved"));
            }
            saveMessages(pRequest, errors);
        } catch (Exception e) {
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        return forward;
    }
    /**
     * 
     * Supprime l'audit de jalon programm pour l'application.
     * 
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward deleteMilestone(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        try {
            // Rcupration de l'application
            CreateApplicationForm applicationForm = (CreateApplicationForm) pRequest.getSession().getAttribute("createApplicationForm");
            Long auditId = new Long(applicationForm.getMilestoneAudit().getId()); // Obtention de l'AC
            IApplicationComponent ac = AccessDelegateHelper.getInstance("ApplicationAdmin");
            Object[] paramIn = { auditId };
            forward = pMapping.findForward("success");
            // Excution de l'AC en vrifiant que la suppression c'est bien effectue
            if (((Integer) ac.execute("removeAudit", paramIn)).intValue() == 1) {
                // L'excution dans la base pose problme
                // On renvoie un message d'erreur neutre
                ActionMessage error = new ActionMessage("error.application.audit.not_deleted");
                errors.add("milestoneMsg", error);
                saveMessages(pRequest, errors);
                forward = pMapping.findForward("failure");
            } else {
                ActionMessage message = new ActionMessage("info.audit_removed", applicationForm.getMilestoneAudit().getName());
                // Mise  jour du form dans la session
                applicationForm.resetMilestoneAudit();
                pRequest.getSession().setAttribute("createApplicationForm", applicationForm);
                errors.add("milestoneMsg", message);
                saveMessages(pRequest, errors);
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);
        return forward;
    }

    /**
     * 
     * Modifie l'audit de jalon programm pour l'application.
     * 
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward modifyMilestone(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {

        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        try {
            // Rcupration de l'id de l'audit
            CreateApplicationForm applicationForm = ManageApplicationUtils.getCreateApplicationForm(((AuditForm) pForm).getApplicationId(), pRequest);
            long auditId = applicationForm.getMilestoneAudit().getId();
            // Prparation de l'audit
            AuditDTO auditDTO = (AuditDTO) WTransformerFactory.formToObj(AuditTransformer.class, (WActionForm) pForm)[0];
            auditDTO.setID(auditId);
            auditDTO.setStatus(AuditBO.NOT_ATTEMPTED);
            auditDTO.setType(AuditBO.MILESTONE);
            if (null == auditDTO.getHistoricalDate()) {
                // On affecte la date du jour
                Calendar today = GregorianCalendar.getInstance();
                auditDTO.setHistoricalDate(today.getTime());
            }
            // Obtention de l'AC
            IApplicationComponent ac = AccessDelegateHelper.getInstance("ApplicationAdmin");
            Object[] paramIn = { auditDTO };
            forward = pMapping.findForward("success");
            // Excution de l'AC
            AuditDTO result = (AuditDTO) ac.execute("modifyAudit", paramIn);
            if (null == result) {
                // L'excution dans la base pose problme
                // On renvoie un message d'erreur neutre
                ActionMessage error = new ActionMessage("error.application.audit.not_modified");
                errors.add("milestoneMsg", error);
                saveMessages(pRequest, errors);
                forward = pMapping.findForward("failure");
            } else {
                ActionMessage message = new ActionMessage("info.audit_modified", result.getName());
                errors.add("milestoneMsg", message);
                saveMessages(pRequest, errors);
                // Mise  jour du form dans la session
                applicationForm.setMilestoneAudit(result);
                pRequest.getSession().setAttribute("createApplicationForm", applicationForm);
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        //On est pass par un menu donc on rinitialise le traceur
        resetTracker(pRequest);
        return forward;
    }

    /**
     * Permet de vrifier que tous les champs sont renseigns dans le premier formulaire d'ajout de 
     * projets.
     * 
     * @param pProjectForm formulaire de projet en cration
     * @return la validit du formulaire.
     */
    private boolean checkProjectForm(final CreateProjectForm pProjectForm) {
        // Vrification du nom de projet non vide,
        // du profil et du source management du projet
        return (pProjectForm.getProjectName().trim().length() > 0) && (pProjectForm.getProfile().trim().length() > 0) && (pProjectForm.getSourceManagement().trim().length() > 0);
    }

    /**
     * Vrifie si le projet existe dj, ou sinon, si son nom est disponible. 
     * 
     * @param pProject le projet.
     * @param pRequest la requete http
     * @return la validit du projet
     * @throws WTransformerException si erreur dans la transformation
     * @throws JrafEnterpriseException si erreur JRAF
     */
    private boolean isNameAvailable(CreateProjectForm pProject, HttpServletRequest pRequest) throws JrafEnterpriseException, WTransformerException {
        // On rcupre l'application courant
        CreateApplicationForm appliForm = ManageApplicationUtils.getCreateApplicationForm(pProject.getApplicationId(), pRequest);
        List projects = appliForm.getProjects();
        boolean isNameAvailable = true;
        // Dja si le nom du projet n'est pas correct, on renvoie true pour que le projet ne soit pas persist
        if (checkProjectForm(pProject)) {
            // Si le projet n'a jamais t persiste, on vrifie que son nom est disponible
            CreateProjectForm project = null;
            for (int i = 0; i < projects.size() && isNameAvailable; i++) {
                project = (CreateProjectForm) projects.get(i);
                // le nom est disponible si :
                // ce n'est pas le meme nom
                // ou c'est le meme nom mais avec le meme id (on modifie un projet dj existant)
                isNameAvailable =
                    (!project.getProjectName().equals(pProject.getProjectName()))
                        || (project.getProjectName().equals(pProject.getProjectName()) && project.getProjectId().equals(pProject.getProjectId()));
                if (project.getProjectId().equals("-1")) {
                    // Le nom est disponible puisque le projet n'a pas persist.
                    // Par contre il faut supprimer le projet dans la liste
                    isNameAvailable = !isNameAvailable;
                    projects.remove(i);
                }
            }
        }
        // par apport au nom de la mthode faut renvoyer le contraire
        return isNameAvailable;
    }

    /**
     * 
     * Confirmation de purge d'une application.
     * La purge d'une application se fait aprs avoir eu une confirmation de celle-ci
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward purgeConfirm(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        return pMapping.findForward("application_confirm_purge");
    }

    /**
     * 
     * Purge d'une application.
     * 
     * @param pMapping le mapping.
     * @param pForm le formulaire  lire.
     * @param pRequest la requte HTTP.
     * @param pResponse la rponse de la servlet.
     * @return l'action  raliser.
     */
    public ActionForward purge(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        ActionMessages errors = new ActionMessages();
        ActionForward forward;
        try {
            // Prparation de l'application
            CreateApplicationForm form = (CreateApplicationForm) pForm;
            ApplicationConfDTO applicationConf = new ApplicationConfDTO();
            applicationConf.setId(new Long(form.getApplicationId()).longValue());
            applicationConf.setName(form.getApplicationName());
            // Purge de l'application
            IApplicationComponent ac = AccessDelegateHelper.getInstance("Purge");
            Object[] paramIn = { applicationConf };
            ac.execute("purgeApplication", paramIn);

            // Envoi d'un mail aux administrateurs et aux gestionnaires de l'application pour leur signaler 
            // qu'une application a t supprime
            String sender = WebMessages.getString(getLocale(pRequest), "mail.sender.squale");
            String header = WebMessages.getString(getLocale(pRequest), "mail.header");
            String object = sender + WebMessages.getString(pRequest, "mail.appli.deleted.object");
            SimpleDateFormat formator = new SimpleDateFormat(WebMessages.getString(getLocale(pRequest), "date.format.simple"));
            String today = formator.format(Calendar.getInstance().getTime());
            Object[] params = { form.getApplicationName(), today, pRequest.getRemoteUser()};
            String content = header + MessageFormat.format(WebMessages.getString(pRequest, "mail.appli.deleted.content"), params);
            content += "\n\n" + WebMessages.getString(pRequest, "mail.appli.deleted.content.users");
            // On affiche les utilisateurs de l'application
            for (Iterator it = form.getRights().keySet().iterator(); it.hasNext();) {
                String user = (String) it.next();
                content += "\n" + user + " - " + WebMessages.getString(getLocale(pRequest), (String) form.getRights().get(user));
            }
            SqualeCommonUtils.notifyByEmail(MailerHelper.getMailerProvider(), SqualeCommonConstants.MANAGERS_AND_ADMINS, new Long(applicationConf.getId()), object, content, false);

            // On recharge les profils de l'utilisateur
            ActionUtils.refreshUser(pRequest);
            // On place un message de confirmation de la purge
            ActionMessage message = new ActionMessage("info.purge_application", applicationConf.getName());
            errors.add(ActionMessages.GLOBAL_MESSAGE, message);
            saveMessages(pRequest, errors);
            // On redirige vers la page de fin de purge dpendant du statut de l'application et de l'utilisateurs
            // lors de la suppression
            LogonBean user = (LogonBean) pRequest.getSession().getAttribute(WConstants.USER_KEY);
            if (ApplicationBO.IN_CREATION == form.getStatus() && user.isAdmin()) {
                forward = pMapping.findForward("ack_application_end_purge");
            } else {
                forward = pMapping.findForward("application_end_purge");
            }
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        return forward;
    }

    /**
     * Enregistrement en session du dernier audit de suivi programm
     * @param pRequest la requte HTTP
     * @param pApplicationId l'id de l'application
     * @throws Exception une exception
     */
    private void loadLastBranchAuditInSession(HttpServletRequest pRequest, long pApplicationId) throws Exception {
        AuditForm lAuditForm = null;
        final AuditDTO lAuditDTO = ManageApplicationUtils.getLastNotAttemptedAudit(pApplicationId);
        if (lAuditDTO != null) {
            lAuditForm = (AuditForm) WTransformerFactory.objToForm(AuditTransformer.class, new Object[] { lAuditDTO });
        }
        pRequest.getSession().setAttribute("auditForm2", lAuditForm);
    }

}
