package com.airfrance.squaleweb.applicationlayer.formbean.component;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionMapping;

import com.airfrance.squaleweb.applicationlayer.formbean.ActionIdFormSelectable;

/**
 * Contient les donnes indispensables relatives  un projet
 * 
 * @author M400842
 */
public class ProjectForm extends ActionIdFormSelectable {
    
    /** Le nombre de niveaux des erreurs */
    public static final int NB_ERRORS_LEVELS = 3;
    
    /** Index pour accder au nombre d'erreurs fatales */
    public static final int ERROR_ID = 0;
    /** Index pour accder au nombre de warning */
    public static final int WARNING_ID = 1;
    /** Index pour accder au nombre d'information */
    public static final int INFO_ID = 2;

    /** Les erreurs */
    private int[] mErrorsRepartition = new int[NB_ERRORS_LEVELS];

    /** Les tches en erreur fatale*/
    private List mFailedTasks = new ArrayList(0);

    /** l'ventuelle justification associe au composant */
    private String justification;

    /** un boolen permettant de savoir si le composant est  exclure du plan d'aciton */
    private boolean excludedFromActionPlan;

    /**
     * @return true si le composant est exclu du plan d'action
     */
    public boolean getExcludedFromActionPlan() {
        return excludedFromActionPlan;
    }

    /**
     * @return la justification du composant
     */
    public String getJustification() {
        return justification;
    }

    /**
     * @param pExcluded le boolen indiquant si il faut exclure le composant ou pas
     */
    public void setExcludedFromActionPlan(boolean pExcluded) {
        excludedFromActionPlan = pExcluded;
    }

    /**
     * @param pJustification la nouvelle valeur de la justification
     */
    public void setJustification(String pJustification) {
        justification = pJustification;
    }

    /**
     * @see org.apache.struts.action.ActionForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest
     * {@inheritDoc}
     * A implmenter sinon on ne peut pas dcocher la checkBox
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {
        super.reset(mapping, request);
        // Reinitialisation du checkbox
        excludedFromActionPlan = false;
    }

    /**
     * @return l'id de l'application parent
     */
    public long getParentId() {
        long result = -1;
        if (!getApplicationId().equals("")) {
            result = new Long(getApplicationId()).longValue();
        }
        return result;
    }

    /**
     * @return le nombre d'erreurs lis  ce projet
     */
    public int getNbOfErrors() {
        return mErrorsRepartition[0]+mErrorsRepartition[1]+mErrorsRepartition[2];
    }

    /**
     * @return les erreurs lis  ce projet
     */
    public int[] getErrorsRepartition() {
        return mErrorsRepartition;
    }

    /**
     * @param pErrors la nouvelle rpartition des erreurs
     */
    public void setErrors(int[] pErrors) {
        mErrorsRepartition = pErrors;
    }

    /** 
     * un boolen juste pour indiquer si le projet a un audit termin,
     * n'est pas stock en base sert juste pour l'affichage
     */
    private boolean hasTerminatedAudit;

    /**
     * @return le boolen indiquant si le projet a un audit termin
     */
    public boolean getHasTerminatedAudit() {
        return hasTerminatedAudit;
    }

    /**
     * @param pHasTerminatedAudit le boolen indiquant si le projet a un audit termin
     */
    public void setHasTerminatedAudit(boolean pHasTerminatedAudit) {
        hasTerminatedAudit = pHasTerminatedAudit;
    }

    /**
     * @return les tches en chec
     */
    public List getFailedTasks() {
        return mFailedTasks;
    }

    /**
     * @param pTasks les tches en chec
     */
    public void setFailedTasks(List pTasks) {
        mFailedTasks = pTasks;
    }

}
