package com.airfrance.squaleweb.applicationlayer.formbean.results;

/**
 * Bean reprsentant les transgressions pour l'export PDF
 */
public class RuleCheckingPDFForm extends RulesCheckingForm {

    /** Dtails de la rgles */
    private RuleCheckingItemsListForm mDetails;
    
    /**
     * Constructeur par dfaut
     */
    public RuleCheckingPDFForm() {
        this("", "", 0, new RuleCheckingItemsListForm());
    }
    
    /**
     * @param pNameRule le nom de la rgle
     * @param pSeverity la svrit de la rgle
     * @param pTransgressionsNumber le nombre de transgressions
     * @param pItemsForm les dtails de la rgles
     */
    public RuleCheckingPDFForm(String pNameRule, String pSeverity, int pTransgressionsNumber, RuleCheckingItemsListForm pItemsForm) {
        mNameRule = pNameRule;
        mSeverity = pSeverity;
        mTransgressionsNumber = pTransgressionsNumber;
        mDetails = pItemsForm;
    }

    /**
     * @return les dtails de la rgles
     */
    public RuleCheckingItemsListForm getDetails() {
        return mDetails;
    }

    /**
     * @param pItems les dtails de la rgles
     */
    public void setDetails(RuleCheckingItemsListForm pItems) {
        mDetails = pItems;
    }

}
