package com.airfrance.squaleweb.transformer.stats;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import com.airfrance.squalecommon.datatransfertobject.stats.SetOfStatsDTO;
import com.airfrance.squaleweb.applicationlayer.formbean.stats.AuditsStatsForm;
import com.airfrance.squaleweb.applicationlayer.formbean.stats.FactorsStatsForm;
import com.airfrance.squaleweb.applicationlayer.formbean.stats.SetOfStatsForm;
import com.airfrance.welcom.struts.bean.WActionForm;
import com.airfrance.welcom.struts.transformer.WITransformer;
import com.airfrance.welcom.struts.transformer.WTransformerException;
import com.airfrance.welcom.struts.transformer.WTransformerFactory;

/**
 */
public class SetOfStatsTransformer implements WITransformer {

    /**
      * @param pObject l'objet  transformer
      * @throws WTransformerException si un pb apparait.
      * @return le formulaire.
      */
    public WActionForm objToForm(Object[] pObject) throws WTransformerException {
        SetOfStatsForm form = new SetOfStatsForm();
        objToForm(pObject, form);
        return form;
    }

    /**
     * @param pObject l'objet  transformer
     * @param pForm le formulaire  remplir.
     * @throws WTransformerException si un pb apparait.
     */
    public void objToForm(Object[] pObject, WActionForm pForm) throws WTransformerException {
        SetOfStatsDTO dto = (SetOfStatsDTO) pObject[0];
        Locale locale = (Locale) pObject[1];
        SetOfStatsForm form = (SetOfStatsForm) pForm;
        // Rcupre les 3 listes contenant les objets bas niveau  transformer
        List profilDto = dto.getListOfProfilsStatsDTO();
        List siteDto = dto.getListOfSiteStatsDTO();
        List applicationsStatsDto = dto.getListOfApplicationsStatsDTO();
        // Les 3 listes qui contiendront les objets transforms
        List profilFormList = new ArrayList(0);
        List siteFormList = new ArrayList(0);
        List applicationFormList = new ArrayList(0);
        for (int i = 0; i < profilDto.size(); i++) {
            // Transforme et ajoute chaque objet profil
            profilFormList.add(WTransformerFactory.objToForm(ProfileStatsTransformer.class, profilDto.get(i)));
        }
        for (int i = 0; i < siteDto.size(); i++) {
            // Transforme et ajoute chaque
            siteFormList.add(WTransformerFactory.objToForm(SiteStatsTransformer.class, siteDto.get(i)));
        }
        for (int i = 0; i < applicationsStatsDto.size(); i++) {
            // Transforme et ajoute chaque statistique
            applicationFormList.add(WTransformerFactory.objToForm(ApplicationStatsTransformer.class, new Object[]{applicationsStatsDto.get(i), locale}));
        }
        form.setListOfProfilsStatsForm(profilFormList);
        form.setListOfSiteStatsForm(siteFormList);
        form.setListOfApplicationsStatsForm(applicationFormList);
        form.setAuditsStatsForm((AuditsStatsForm)WTransformerFactory.objToForm(AuditsStatsTransformer.class,dto.getAuditsStatsDTO()));
        form.setFactorsStatsForm((FactorsStatsForm)WTransformerFactory.objToForm(FactorsStatsTransformer.class,dto.getFactorsStatsDTO()));
    }

    /**
     * @deprecated n'a pas de sens
     * @param pForm le formulaire
     * @throws WTransformerException si un pb apparait.
     * @return rien mais lance systmatiquement une exception
     */
    public Object[] formToObj(WActionForm pForm) throws WTransformerException {
        throw new WTransformerException("deprecated");
    }

    /**
     * @deprecated n'a pas de sens
     * @param pForm le formulaire
     * @param pTab les paramtres
     * @throws WTransformerException si un pb apparait.
     */
    public void formToObj(WActionForm pForm, Object[] pTab) throws WTransformerException {
        throw new WTransformerException("deprecated");
    }

}
