package com.airfrance.squaleweb.util;

import com.airfrance.squalecommon.enterpriselayer.businessobject.profile.ProfileBO;

/**
 * Contient les constantes ncessaires  la vue et au controlleur
 * 
 * @author M400842
 */
public abstract class SqualeWebConstants {
    /**
     * Liste des profils sur les applications
     * <br>
     * A mettre en relation avec le fichier d'externalisation du projet common.
     */
    public final static String[] PROFILES = { ProfileBO.READER_PROFILE_NAME, ProfileBO.MANAGER_PROFILE_NAME };

    /** 
     * Contient la cl de rfrence de l'attribut de session
     * contenant la liste des rsultats courants  afficher.
     */
    public final static String RESULTS_KEY = "results";

    /**
     * Contient la cl de rfrence de l'attribut de session
     * contenant la liste des tops d'un projet 
     */
    public final static String TOP_KEY = "top";

    /**
     * Contient la cl de rfrence de l'attribut de session
     * contenant la liste des notes des pratiques courantes  afficher.
     */
    public final static String PRACTICES_KEY = "practices";

    /**
     * Contient la cl de rfrence de l'attribut de session
     * contenant la liste des notes des pratiques courantes  afficher dans la vue mto
     */
    public final static String PRACTICES_LIST_KEY = "practices.meteo";

    /**
     * Contient la cl de rfrence de l'attribut de session
     * contenant la liste des composants enfants  afficher.
     */
    public final static String CHILDREN_KEY = "children";

    /**
     * Contient la cl de rfrence de l'attribut de session
     * contenant la liste des dtails d'une transgression  afficher.
     */
    public final static String ITEMS_KEY = "items";

    /**
     * Cl dsignant le traceur pour la navigation dans la hirarchie de classe
     */
    public final static String TRACKER_COMPONENT = "browsing.tracker.component";
    /**
     * Cl dsignant le traceur pour la navigation historique
     */
    public final static String TRACKER_HIST = "browsing.tracker.hist";
    /**
     * Cl indiquant si on vient directement d'une vue composant ou non,
     * sert pour le traceur
     */
    public final static String TRACKER_BOOL = "browsing.tracker.bool";
    /**
     * Cl indiquant si le traceur doit etre rinitialis
     */
    public final static String TRACKER_RESET = "browsing.tracker.reset";
    /**
     * Cl pour ce qui va s'afficher dans l'onglet "information gnrale"
     */
    public final static String GEN_INFO = "browsing.tracker.info";
    /**
     * Cl dsignant la pratique pour laquelle on affiche les composants
     */
    public final static String TRE_DETAILS_NAME = "browsing.tre.name";
    /**
     * Cl dsignant la note de la pratique pour laquelle on affiche les composants
     */
    public final static String TRE_DETAILS_MARK = "browsing.tre.mark";
    /**
     * Contient la cl de rfrence de l'attribut de session
     * spcifiant si une page  t valide (review.jsp)
     */
    public final static String VALIDATED = "is.validated";

    /**
     * Contient la cl de rfrence du maker scatterplott
     */
    public final static String BUBBLE_GRAPH = "bubbleGraph.key";

    /**
     * Contient la cl de rfrence du chart du scatterplott
     */
    public final static String BUBBLE_CHART = "bubbleChart.key";

    /**
     * Contient la cl de rfrence du GraphMaker du scatterplott
     */
    public final static String BUBBLE_GRAPH_MAKER = "bubbleGraphMaker.key";

    /**
     * Contient la cl indiquant si on a cre un nouveau projet
     * permet de savoir quand on doit envoyer un mail
     */
    public final static String NEW_PROJECT = "new_project";
    
    /**
     * Cl qui indique si on vient de la page mark.jsp
     */
    public final static String FROM_MARK_PAGE_KEY = "fromMarkPage";
    
    /** 
     * Cl pour retrouver la prcdente action dans le cas de bouton retour.
     */
    public static final String RETURN_ACTION_KEY = "returnAction";
}
