package com.airfrance.squaleweb.util.graph;

import org.jfree.chart.urls.CategoryURLGenerator;
import org.jfree.data.category.CategoryDataset;

/**
 */
public class RepartitionBarUrlGenerator extends AbstractRepartitionUrlGenerator implements CategoryURLGenerator {

    /**
     * Constructeur, initialise les champs communs  tout le graphe 
     * @param pProjectId l'id du projet 
     * @param pCurrentAuditId l'id de l'audit
     * @param pPreviousAuditId  pPreviousAuditId
     * @param pPracticeId l'id de la pratique
     * @param pFactorParentId l'id du facteur parent
     * @param pNbSeries le nombre de sries que contient le graph
     */
    public RepartitionBarUrlGenerator(String pProjectId, String pCurrentAuditId,String pPreviousAuditId, String pPracticeId, String pFactorParentId, int pNbSeries) {
        mProjectId = pProjectId;
        mCurrentAuditId = pCurrentAuditId;
        mPreviousAuditId = pPreviousAuditId;
        practiceId = pPracticeId;
        factorParent = pFactorParentId;
        nbSeries = pNbSeries;
    }

    /** 
     * Implmente la gnration d'url
     * @param pDataSet les donnes
     * @param pSerieIndex l'index de la srie sur lequel on va dfinir l'url
     * @param pCategory la catgorie
     * @see org.jfree.chart.urls.CategoryURLGenerator#generateURL(org.jfree.data.category.CategoryDataset, int, int)
     * @return l'url
     */
    public String generateURL(CategoryDataset pDataSet, int pSerieIndex, int pCategory) {
        return super.generateURL(pDataSet, pSerieIndex, pCategory);
    }

}
