package com.airfrance.squalix.util.file;

import com.airfrance.squalecommon.util.messages.BaseMessages;

/**
 * Messages pour FileUtility
 */
public class FileMessages extends BaseMessages {
    /** Instance */
    static private FileMessages mInstance = new FileMessages();
    
    /**
     * Retourne la chane de caractre spcifie par la cl.
     * @param pKey nom de la cl.
     * @return la chane associe.
     */
    public static String getString(String pKey) {
        return mInstance.getBundleString(pKey);
    }
    
    /**
     * Constructeur priv pour viter l'instanciation
     */
    private FileMessages() {
        super("com.airfrance.squalix.util.file.file");
    }

    /**
     * Retourne la chane de caractre identifie par la cl.
     * @param pKey nom de la cl.
     * @param pValues les valeurs  insrer dans la chaine
     * @return la chane associe.
     */
    public static String getString(String pKey, Object[] pValues) {
        return mInstance.getBundleString(pKey, pValues);
    }

    /**
     * @param pKey clef
     * @param pArgument argument
     * @return chane associe
     */
    public static String getString(String pKey, Object pArgument) {
        return getString(pKey, new Object[] { pArgument });
    }
}
