package com.airfrance.squaleide.util;

import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 * Classe utilitaires
 */
public class PluginUtils {
    
    /**
     * Remplace la premire occurence de pToCut dans pString
     * @param pToCut la chane  enlever
     * @param pString la chane  qui on doit enlever pToCut
     * @return pString - la premire occurence de pToCut
     */
    public static String replaceFirst(String pToCut, String pString) {
        String result = pString;
        // On recherche l'index de pToCut
        int id = pString.indexOf(pToCut);
        if(id >= 0) {
            // On rcupre pString - pToCut
            result = pString.substring(0, id);
            result += pString.substring(id+pToCut.length());
        }
        return result;
    }

    /**
     * Forme une chane en concatnant les lments de <code>items</code> par <code>separator</code>
     * @param items les tags
     * @param separator le sparateur
     * @return la chane unique reprsentant la liste des tags
     */
    public static String createListString(String[] items, String separator) {
        StringBuffer path = new StringBuffer("");
        // On parcours la liste des tags
        for (int i = 0; i < items.length; i++) {
            path.append(items[i]);
            // On spare par le sparateur
            path.append(separator);
        }
        return path.toString();
    }

    /**
     * Cree un tableau de String reprsentant les lments spars par <code>separator</code>
     * @param stringList la chane reprsentant la liste des tags
     * @param separator le sparateur
     * @return le tableau des items
     */
    public static String[] parseString(String stringList, String separator) {
        // On va itrer sur chaque sparateur
        StringTokenizer st = new StringTokenizer(stringList, separator);
        List v = new ArrayList();
        while (st.hasMoreElements()) {
            v.add(st.nextElement());
        }
        return (String[]) v.toArray(new String[v.size()]);
    }

}
