package com.airfrance.squaleide.xml;

/**
 * Objet reprsentant une transgressions dans le fichier XML de l'export IDE
 */
public class IdeTransgression {
    
    /** Svrit de type error */
    public static final String ERROR_SEVERITY = "error";
    /** Svrit de type warning */
    public static final String WARNING_SEVERITY = "warning";
    /** Svrit de type info */
    public static final String INFO_SEVERITY = "info";
    
    /** La description de l'erreur */
    private String mDescription;
    
    /** Le rpertoire dans lequel se trouve le fichier concern */
    private String mInFolder;
    
    /** La ligne sur laquelle se porte l'erreur */
    private int mLocation;
    
    /** Le nom du fichier concern par l'erreur */
    private String mResource;
    
    /** Svrit de la transgression (erreur par dfaut) */
    private String mSeverity;
    
    /**
     * Constructeur par dfaut
     */
    public IdeTransgression() {
        mDescription = "";
        mInFolder = "";
        mResource = "";
        mSeverity = ERROR_SEVERITY;
    }

    /**
     * @return la description de l'erreur
     */
    public String getDescription() {
        return mDescription;
    }

    /**
     * @return le rpertoire dans lequel se trouve le fichier concern
     */
    public String getInFolder() {
        return mInFolder;
    }

    /**
     * @return la ligne sur laquelle se porte l'erreur
     */
    public int getLocation() {
        return mLocation;
    }

    /**
     * @return le nom du fichier concern par l'erreur
     */
    public String getResource() {
        return mResource;
    }

    /**
     * @param pDescription la description de l'erreur
     */
    public void setDescription(String pDescription) {
        mDescription = pDescription;
    }

    /**
     * @param pFolder le rpertoire dans lequel se trouve le fichier concern
     */
    public void setInFolder(String pFolder) {
        mInFolder = pFolder;
    }

    /**
     * @param pLine la ligne sur laquelle se porte l'erreur
     */
    public void setLocation(int pLine) {
        mLocation = pLine;
    }

    /**
     * @param pFileName le nom du fichier concern par l'erreur
     */
    public void setResource(String pFileName) {
        mResource = pFileName;
    }

    /**
     * @return la svrit de la rgle
     */
    public String getSeverity() {
        return mSeverity;
    }

    /**
     * @param pSeverity la svrit de la rgle
     */
    public void setSeverity(String pSeverity) {
        mSeverity = pSeverity;
    }

}
