package com.airfrance.squaleide.xml;

import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.digester.Digester;
import org.xml.sax.SAXException;

/**
 * 
 */
public class ImportIdeActionPlan {

    /**
     * Importation du plan d'action
     * @param pStream flux de configuration
     * @return le plan d'action sous la forme d'un IdeActionPlan
     * @throws IOException si erreur de fichier
     * @throws SAXException si erreur de parsing
     */
    public static IdeActionPlan importConfig(InputStream pStream) throws IOException, SAXException {

        IdeActionPlan actionPlan = new IdeActionPlan();

        Digester configDigester = setupDigester();
        actionPlan = (IdeActionPlan) configDigester.parse(pStream);
        pStream.close();
        return actionPlan;
    }

    /**
      * Configuration du digester
      * Le digester est utilis pour le chargement du fichier XML de rgles
      * @return digester
      */
    private static Digester setupDigester() {
        Digester configDigester = new Digester();

        // Traitement de la configuration
        configDigester.addObjectCreate("squaleLink-config", IdeActionPlan.class);
        configDigester.addSetProperties("squaleLink-config");

        // Traitement des paramtres gnraux
        configDigester.addObjectCreate("squaleLink-config/transgression", IdeTransgression.class);
        configDigester.addSetProperties("squaleLink-config/transgression");
        configDigester.addSetNext("squaleLink-config/transgression", "addTransgression");
        return configDigester;
    }

}
