/*
 * Cr le 4 aot 05
 *
 * Pour changer le modle de ce fichier gnr, allez  :
 * Fentre&gt;Prfrences&gt;Java&gt;Gnration de code&gt;Code et commentaires
 */

package com.airfrance.squale.utils.javadoc;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * @author M400843
 *
 */
public class JavadocMessages {

    /**
     * Chemin du fichier de proprits.
     */
    private static final String BUNDLE_NAME = "com.airfrance.squale.utils.javadoc.javadoc";
    /**
     * Instance de ResourceBudle utilise.
     */
    private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);

    /**
     * Constructeur par dfaut. Priv pour viter l'instanciation.
     */
    private JavadocMessages() {
    }

    /**
     * Retourne la chane de caractre identifie par la cl.
     * @param pKey nom de la cl.
     * @return la chane associe.
     */
    private static String getString(String pKey) {
        String value = null;
        try {
            value = RESOURCE_BUNDLE.getString(pKey);
        } catch (MissingResourceException e) {
            // TODO
        }
        return value;
    }

    /**
     * 
     * @param pKey cl du tag
     * @return le nom du tag
     */
    public static String getTagName(String pKey) {
        return getString(pKey + ".name");
    }

    /**
     * 
     * @param pKey cl du tag
     * @return la description correspondant au tag
     */
    public static String getDescription(String pKey) {
        return getString(pKey + ".description");
    }

    /**
     * 
     * @param pKey cl du tag
     * @return <code>true</code> si ce tag doit etre prsent dans la javadoc
     */
    private static boolean getEnabled(String pKey) {
        return Boolean.valueOf(getString(pKey + ".enabled")).booleanValue();
    }

    /**
     * 
     * @param pKey cl du tag
     * @return le scope du tag (sous forme de chaine : method, class, ...)
     */
    private static String getTagScope(String pKey) {
        return getString(pKey + ".scope");
    }

    /**
     * 
     * @param pKey cl du tag
     * @return le scope du tag (sous forme d'une lettre : a, X, c, ... )
     */
    public static String getScope(String pKey) {
        String scope = getTagScope(pKey);

        if (getEnabled(pKey)) {
            scope = getString("scope." + scope);
        } else {
            scope = getString("scope.disable");
        }

        return scope;
    }
}
